import 'package:flutter/material.dart';
import 'package:hgg_view/hgg_view.dart';
import 'package:hgg_view/src/theme/h_colors.dart';

/// 应用 Card
class XCard extends StatelessWidget {
  final GestureTapCallback? onTap;
  final bool hasButtonOnTop;
  final Widget child;
  final double? marginTop;
  final double? marginBottom;
  final EdgeInsetsGeometry? padding;
  final double? height;
  final Color? color;

  const XCard({
    Key? key,
    required this.child,
    this.onTap,
    this.hasButtonOnTop = false,
    this.marginTop,
    this.marginBottom,
    this.padding,
    this.height,
    this.color,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    if (onTap == null) {
      return XContainer(
        margin: P.only(
            left: 32, right: 32, top: marginTop, bottom: marginBottom),
        padding: padding,
        color: color ?? HColors.FF_1F1B34,
        radius: 26,
        height: height,
        child: child,
      );
    } else {
      final xContainer = XContainer(
        padding: padding,
        color: HColors.FF_1F1B34,
        radius: 26,
        height: height,
        child: child,
      );
      return Padding(
        padding: P.only(
            left: 32, right: 32, top: marginTop, bottom: marginBottom),
        child: hasButtonOnTop
            ? InkWell(
          onTap: onTap,
          borderRadius: XRadius.circular(26),
          child: xContainer,
        )
            : XInkWell(
          onTap: onTap,
          borderRadius: XRadius.circular(26),
          child: xContainer,
        ),
      );
    }
  }
}
