import 'package:flutter/material.dart';
import 'package:hgg_view/hgg_view.dart';

/// 自定义 可拖动悬浮按钮
class XFloatButton extends StatefulWidget {
  final VoidCallback onTap;

  const XFloatButton(this.onTap, {Key? key}) : super(key: key);

  @override
  _XFloatButtonState createState() => _XFloatButtonState();
}

class _XFloatButtonState extends State<XFloatButton> {
  Offset? offsetA; //按钮的初始位置

  @override
  Widget build(BuildContext context) {
    // 获取屏幕尺寸
    final size = MediaQuery.of(context).size;
    final width = size.width;
    final height = size.height;

    // 设置初始位置
    final initX = width - D.w(140);
    var initY = height - D.h(280);
    if (GetPlatform.isIOS) {
      initY = height - D.h(320);
    }

    // 设置点击按钮 120
    var xFloatButtionIcon = Icon(
      Icons.add_circle,
      color: Colors.deepPurple,
      size: D.w(120),
    );

    return Positioned(
      left: offsetA != null ? offsetA!.dx : initX,
      top: offsetA != null ? offsetA!.dy : initY,
      child: Draggable(
          //创建可以被拖动的Widget
          /*child: FloatingActionButton(
              child: Icon(Icons.add),
              onPressed: widget.onTap,
            ),*/

          child: XInkWell(
            borderRadius: XRadius.circular(60),
            onTap: widget.onTap,
            child: xFloatButtionIcon,
          ),

          //拖动过程中的Widget
          feedback: xFloatButtionIcon,
          //拖动过程中，在原来位置停留的Widget，设定这个可以保留原本位置的残影，如果不需要可以直接设置为Container()
          childWhenDragging: Container(),

          //拖动结束后的Widget
          onDraggableCanceled: (Velocity velocity, Offset offset) {
            // 计算组件可移动范围  更新位置信息
            setState(() {
              double? x = offset.dx;
              var y = offset.dy;

              if (offset.dx < 0) {
                x = D.w(40);
              }
              if (offset.dx > D.w(650)) {
                x = D.w(610);
              }
              final topHight = D.h(260);
              if (offset.dy < topHight) {
                y = topHight;
              }

              if (offset.dy > initY) {
                y = initY;
              }
              offsetA = Offset(x!, y);
            });
          }),
    );
  }
}
