import 'package:flutter/material.dart';
import 'package:hgg_view/src/theme/h_colors.dart';
import 'package:hgg_view/src/generated/r.dart';

import '../../../hgg_view.dart';

typedef XBoolRadio = XRadioWithTip<bool>;
typedef XStringRadio = XRadioWithTip<String>;
typedef XIntRadio = XRadioWithTip<int>;

class XRadioWithTip<T> extends StatelessWidget {
  const XRadioWithTip({
    Key? key,
    required this.value,
    this.tip = '',
    required this.groupValue,
    required this.onChanged,
    this.height,
    this.mainAxisAlignment,
  }) : super(key: key);

  final T value;
  final String tip;
  final T groupValue;
  final ValueChanged<T> onChanged;
  final double? height;
  final MainAxisAlignment? mainAxisAlignment;

  @override
  Widget build(BuildContext context) {
    return XInkWell(
      onTap: () => onChanged(value),
      child: XContainer(
        height: height ?? double.infinity,
        child: Row(
          mainAxisAlignment: mainAxisAlignment ?? MainAxisAlignment.center,
          children: [
            XRadio<T>.custom(
              value: value,
              groupValue: groupValue,
              onChanged: onChanged,
              width: D.w(30),
              height: D.w(30),
              selected: XImageAsset(
                  R.icon_radio_select_circular2, package: HConfig.package),
              normal: XImageAsset(
                  R.icon_radio_unselect_circular, package: HConfig.package),
            ),
            XText(
              tip,
              color: HColors.FF_DEDEDE,
              fontSize: 26,
              fontWeight: XFontWeight.regular,
              padding: P.only(left: 14),
            )
          ],
        ),
      ),
    );
  }
}
