import 'package:flutter/material.dart';
import 'package:hgg_base/hgg_base.dart';

/// text
class XText extends StatelessWidget {
  const XText(
    this.data, {
    Key? key,
    this.color,
    this.fontSize,
    this.fontWeight,
    this.height,
    this.padding,
    this.maxLines,
    this.textAlign,
    this.keepMaxLinesHeight = false,
  }) : super(key: key);

  final String? data;
  final Color? color;
  final double? fontSize;
  final FontWeight? fontWeight;
  final double? height;
  final EdgeInsetsGeometry? padding;
  final int? maxLines;
  final TextAlign? textAlign;
  final bool keepMaxLinesHeight; // 保持最大行数高度,文字一行,高度页面 maxLines 行高度

  @override
  Widget build(BuildContext context) {
    Widget widget = Text(
      data ?? '',
      maxLines: maxLines,
      overflow: maxLines != null ? TextOverflow.ellipsis : null,
      textAlign: textAlign,
      style: TextStyle(
        color: color,
        fontSize: D.sp(fontSize),
        fontWeight: fontWeight,
        height: height,
      ),
    );
    if (keepMaxLinesHeight && fontSize != null) {
      widget = SizedBox(
        height: D.sp(fontSize) * (height ?? 1) * (maxLines ?? 1),
        child: widget,
      );
    }
    if (padding != null) {
      widget = Padding(
        padding: padding!,
        child: widget,
      );
    }
    return widget;
  }
}

class XFontWeight {
  static const FontWeight regular = FontWeight.normal;
  static const FontWeight medium = FontWeight.w500;
  static const FontWeight bold = FontWeight.bold;
}
