import 'package:flutter/material.dart';
import 'package:hgg_base/hgg_base.dart';
import 'package:hgg_view/src/theme/h_colors.dart';

import 'x_text.dart';

/// 限制宽度,分散分布的 txt
class XWidthText extends StatelessWidget {
  final double widthLimit; //宽度限制
  final String text;
  final Color? color;
  final double? fontSize;
  final FontWeight? fontWeight;
  final double? height;

  const XWidthText(
    this.text, {
    Key? key,
    this.widthLimit = 142,
    this.color,
    this.fontSize,
    this.fontWeight,
    this.height,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      width: D.w(widthLimit),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: text
            .xSplit('')
            .map((str) => XText(
                  str,
                  color: color ?? HColors.FF_DEDEDE,
                  fontSize: fontSize ?? 34,
                  fontWeight: fontWeight ?? XFontWeight.medium,
                  height: height,
                ))
            .toList(),
      ),
    );
  }
}
