import 'package:flutter/material.dart';
import 'package:hgg_view/hgg_view.dart';

/// 容器
class XContainer extends StatelessWidget {
  final double? width;
  final double? height;
  final AlignmentGeometry? alignment;
  final EdgeInsetsGeometry? padding;
  final EdgeInsetsGeometry? margin;
  final BoxConstraints? constraints;
  final bool isCircle;

  final Color? color;
  final Gradient? gradient;
  final double? radius;
  final BorderRadiusGeometry? borderRadius;
  final BoxBorder? border;
  final DecorationImage? image;
  final List<BoxShadow>? boxShadow;

  final Widget? child;

  final double? minHeight;

  const XContainer(
      {Key? key,
      this.width,
      this.height,
      this.alignment,
      this.padding,
      this.margin,
      this.constraints,
      this.isCircle = false,
      this.color,
      this.gradient,
      this.radius,
      this.borderRadius,
      this.border,
      this.image,
      this.boxShadow,
      this.child,
      this.minHeight})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      width: D.w(width),
      height: D.h(height),
      alignment: alignment,
      padding: padding,
      margin: margin,
      constraints:
          constraints ?? (minHeight != null ? BoxConstraints(minHeight: D.h(minHeight)) : null),
      decoration: BoxDecoration(
          color: color,
          gradient: gradient,
          shape: isCircle ? BoxShape.circle : BoxShape.rectangle,
          borderRadius: borderRadius ?? XRadius.circular(radius),
          border: border,
          image: image,
          boxShadow: boxShadow),
      child: child,
    );
  }
}
