import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:hgg_view/hgg_view.dart';
import 'package:hgg_view/src/theme/h_colors.dart';
import 'package:hgg_view/src/theme/h_config.dart';

/// 加载网络图片
class XImageNetwork extends StatelessWidget {
  final String? imageUrl;
  final double? width;
  final double? height;
  final BoxFit fit;
  final BorderRadius? borderRadius;
  final Widget? placeholder;
  final Widget? errorWidget;
  final Color? defaultColor;

  const XImageNetwork(
    this.imageUrl, {
    Key? key,
    this.width,
    this.height,
    this.fit = BoxFit.cover,
    this.borderRadius,
    this.placeholder,
    this.errorWidget,
    this.defaultColor,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    Widget defaultWidget = Container(
      height: D.h(height),
      width: D.w(width),
      color: defaultColor ?? HColors.FF_F0F0F0.withOpacity(.1),
    );

    if (borderRadius != null) {
      defaultWidget = ClipRRect(
        borderRadius: borderRadius,
        child: defaultWidget,
      );
    }

    return XImageNetBase(
      imageUrl ?? '',
      width: width,
      height: height,
      fit: fit,
      imagePrefix: HConfig.imagePrefix,
      borderRadius: borderRadius,
      placeholder: placeholder ?? defaultWidget,
      errorWidget: errorWidget ?? defaultWidget,
    );
  }
}
