import 'package:flutter/material.dart';
import 'package:hgg_view/hgg_view.dart';

/// 可点击的控件,带波纹
class XInkWell extends StatelessWidget {
  final Widget? child;
  final GestureTapCallback? onTap;
  final BorderRadius? borderRadius;
  final double padding;
  final Color? splashColor;
  final Color highlightColor;
  final GestureTapDownCallback? onTapDown;
  final GestureLongPressCallback? onLongPress;

  const XInkWell({
    Key? key,
    this.child,
    this.onTap,
    this.borderRadius,
    this.padding = 0,
    this.splashColor, //水波颜色
    this.highlightColor = Colors.transparent, //高亮颜色
    this.onTapDown,
    this.onLongPress,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[
        Padding(
          padding: P.all(padding),
          child: child,
        ),
        Positioned.fill(
          child: Material(
            color: Colors.transparent,
            child: InkWell(
              splashColor: splashColor ?? Colors.deepPurple.withOpacity(0.1),
              highlightColor: highlightColor,
              onTap: onTap,
              borderRadius: borderRadius,
              splashFactory: InkRipple.splashFactory,
              onTapDown: onTapDown,
              onLongPress: onLongPress,
            ),
          ),
        ),
      ],
    );
  }
}
