import 'package:flutter/material.dart';
import 'package:hgg_view/hgg_view.dart';
import 'package:hgg_view/src/theme/h_colors.dart';
// ignore: import_of_legacy_library_into_null_safe
import 'package:pull_to_refresh/pull_to_refresh.dart';

/// 通用的 header
class XRefreshHeader extends StatelessWidget {
  const XRefreshHeader({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return WaterDropHeader(
      waterDropColor: HColors.app_accent_5A46BE,
      complete: Row(
        mainAxisAlignment: MainAxisAlignment.center,
        children: <Widget>[
          const Icon(Icons.done, color: HColors.app_accent_5A46BE),
          G.h(30),
          const Text('刷新完成', style: TextStyle(color: Colors.grey))
        ],
      ),
      refresh: const SizedBox(
        width: 25,
        height: 25,
        child: CircularProgressIndicator(
          strokeWidth: 2.0,
          valueColor: AlwaysStoppedAnimation(HColors.app_accent_5A46BE),
        ),
      ),
    );
  }
}

/// 通用的 footer
class XRefresherFooter extends StatelessWidget {
  const XRefresherFooter({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return const ClassicFooter(
      canLoadingText: '上滑加载更多',
      failedText: '加载失败,请点击重试',
      noDataText: '没有更多数据了',
      loadingText: '加载中...',
      idleText: '',
      idleIcon: null,
      loadingIcon: SizedBox(
        width: 25,
        height: 25,
        child: CircularProgressIndicator(
          strokeWidth: 2.0,
          valueColor: AlwaysStoppedAnimation(HColors.app_accent_5A46BE),
        ),
      ),
    );
  }
}
